/*
 * Marcin Owsiany 8:00
 * 3 18.11.2000
 * 4 6
 */

#include <stdlib.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>

#define PIDS 1024

static pid_t pipes[PIDS];

FILE *my_popen(char *cmd, const char *mode)
{
	int fds[2], p;
	
	fprintf(stderr, "Using popen()\n");
	
	if (pipe(fds) != 0) return NULL;
	if ((p = fork()) == 0) {
		if (*mode == 'w') { 		/* potomek ma czyta */
			dup2(fds[0], 0);
			if (close(fds[0]) == -1) exit(EXIT_FAILURE);
			if (close(fds[1]) == -1) exit(EXIT_FAILURE);
		} else if (*mode == 'r') { 	/* potomek ma pisa */
			dup2(fds[1], 1);
			if (close(fds[0]) == -1) exit(EXIT_FAILURE);
			if (close(fds[1]) == -1) exit(EXIT_FAILURE);
		} else exit(EXIT_FAILURE);
		exit(system(cmd));
	} else if (p != -1) {
		if (*mode == 'w') {		/* ojciec ma pisa */
			if (close(fds[0]) == -1) return NULL;
			pipes[fds[1]] = p;
			return(fdopen(fds[1], mode));
		} else if (*mode == 'r') {	/* ojciec ma czyta */
			if (close(fds[1]) == -1) return NULL;
			pipes[fds[0]] = p;
			return(fdopen(fds[0], mode));
		} else return NULL;
	} else return NULL;			/* failed fork() */
}

int my_pclose(FILE *stream)
{
	int stat, p;

	fprintf(stderr, "Using pclose()\n");

	p = pipes[fileno(stream)];
	fclose(stream);
	waitpid(p, &stat, 0);
	return stat;
}
